#!/usr/bin/python
# -*- coding: utf-8 -*-
#
#.py

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from Driza import salida
from Driza.widgets import woperaciones

class Operacion:
	def __init__(self,nombre,datos,widget,funcion,interfazresultado,initresultado):
		self.__dato=datos
		self.nombre=nombre
		self.interfazresultado=interfazresultado
		self.initresultado=initresultado
		self.resultado=None
		self.funcion=funcion
		if widget["tipo"]=="CalculoSimple":
			self.widget=woperaciones.WidgetCalculoSimple(self.nombre,widget["opciones"],datos)
		elif widget["tipo"]=="BondadDeAjuste":
			self.widget=woperaciones.WidgetCalculoSimpleBondadAjuste(self.nombre,datos)
		elif widget["tipo"]=="CalculoDoble":
			self.widget=woperaciones.WidgetCalculoDoble(self.nombre,widget["opciones"],datos)
		elif widget["tipo"]=="Graficos":
			self.widget=woperaciones.WidgetGraficos(self.nombre,widget["opciones"],datos)
		else:
			print "ERROR"

	def procedimiento(self):
		"""Esta funcion llama a la funcion "funcion" definida por cada operacion, y despues crea un objeto del tipo salida, tambien definido en cada operacion
		Finalmente, lo devuelve para la ventana de salida"""

		#Obtenemos los datos que ha introducido el usuario
		variables=self.widget.seleccion()
		opciones=self.widget.opciones()

		lista=[]
		caso=None #PArche
		for variable in variables:
			lista.append([variable,caso,self.funcion(self.__dato,variable,caso,opciones)])
		
		#Creamos el resultado de salida
		resultado=salida.Resultado()
		self.initresultado(resultado,opciones)

		#Rellenamos con los resultados obtenidos por R

		for x in lista:
			self.interfazresultado(resultado,x[0],x[1],x[2])

		#Devolvemos el objeto
		return resultado


		#Devolverlo/mandarlo a salida (todavia no se)


