#!/usr/bin/python
# -*- coding: utf-8 -*-
#
#woperaciones.py: Todos los widgets de operaciones

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from qt import *
from Driza.widgets import seleccion
from Driza.widgets import wopciones

class WidgetOperacion(QWidget):
	"""Clase base de todos los widgets de operaciones"""
	def __init__(self,parent,name):
		QWidget.__init__(self,parent,name,0)
		if not name:
			self.setName("WidgetOperacion")


		#layout

		self.rejilla=QGridLayout(self,1,1,11,6,"rejilla")
#		layoutaceptarcancelar = QVBoxLayout(None,0,6,"layoutaceptarcancelar")
#		self.__botonaceptar = QPushButton(self,"Aceptar")
#		layoutaceptarcancelar.addWidget(self.__botonaceptar)
#		self.__botoncancelar = QPushButton(self,"Cancelar")
#		layoutaceptarcancelar.addWidget(self.__botoncancelar)

#		self.rejilla.addLayout(layoutaceptarcancelar,0,1)

		self.languageChange()

		self.resize(QSize(600,480).expandedTo(self.minimumSizeHint()))
		self.clearWState(Qt.WState_Polished)


	def languageChange(self):
		self.setCaption(self.__tr("Form1"))
#		self.__botonaceptar.setText(self.__tr("A&ceptar"))
#		self.__botonaceptar.setAccel(self.__tr("Alt+C"))
#		self.__botoncancelar.setText(self.__tr("Ca&ncelar"))
#		self.__botoncancelar.setAccel(self.__tr("Alt+N"))


	def __tr(self,s,c = None):
		return qApp.translate("Form1",s,c)
	

	def seleccion(self):
		return self.cajas.seleccion

	def opciones(self):
		return self.wopciones.opciones()


class WidgetCalculoSimple(WidgetOperacion):
	"""Es un widget de calculo, con un selector simple y un widget de opciones suministrado en el constructor"""
	def __init__(self,name,widgetopciones,datos):
		WidgetOperacion.__init__(self,None,name)
		self.cajas=seleccion.Selectorsimple(self,datos)
		self.rejilla.addWidget(self.cajas,0,0)
		self.wopciones=widgetopciones
		self.zonastack=QWidgetStack(self,"stack")
		self.rejilla.addWidget(self.zonastack,1,0)
		self.zonastack.setMinimumSize(QSize(200,200))
		self.zonastack.addWidget(self.wopciones)
		self.zonastack.raiseWidget(self.wopciones)


class WidgetCalculoDoble(WidgetOperacion):
	"""Es un widget de calculo, con un selector doble y un widget de opciones suministrado en el constructor"""
	def __init__(self,name,widgetopciones,datos):
		WidgetOperacion.__init__(self,None,name)
		self.cajas=seleccion.Selectordoble(self,datos)
		self.rejilla.addWidget(self.cajas,0,0)
		self.wopciones=widgetopciones
		self.zonastack=QWidgetStack(self,"stack")
		self.rejilla.addWidget(self.zonastack,1,0)
		self.zonastack.setMinimumSize(QSize(200,200))
		self.zonastack.addWidget(self.wopciones)
		self.zonastack.raiseWidget(self.wopciones)


class WidgetCalculoSimpleBondadAjuste(WidgetCalculoSimple):
	"""Es un widget especifico para todas las operaciones de bondad de ajuste"""
	def __init__(self,name,datos):
		widget=wopciones.WOpciones()
		widget.addSSB(u"Distribución","Uniforme")
		widget.addLS("Percentil","95","90")
		WidgetCalculoSimple.__init__(self,name,widget,datos)
		
class WidgetGraficos(WidgetOperacion):
	"""Widget de gráficos. Solicita una imagen en el constructor, y delega las opciones en el widgetopciones"""
	def __init__(self,name,widgetopciones,datos):
		WidgetOperacion.__init__(self,None,name)
		widget=QLabel(self)
		widget.setText("Histograma")
		self.rejilla.addWidget(widget,0,0)
		self.wopciones=widgetopciones
		self.zonastack=QWidgetStack(self,"stack")
		self.rejilla.addWidget(self.zonastack,1,0)
		self.zonastack.setMinimumSize(QSize(200,200))
		self.zonastack.addWidget(self.wopciones)
		self.zonastack.raiseWidget(self.wopciones)
		

